/**
 * cf_thread.h
 */
#ifndef __CF_THREAD_H__
#define __CF_THREAD_H__

#include "cf_base.h"

#ifdef _WIN32
//# include <stddef.h>
# define CF_THREAD_RETURN	uintptr_t
# define CF_THREAD_CALL		__stdcall
#else // #ifdef _WIN32
# define CF_THREAD_RETURN	void *
# define CF_THREAD_CALL
#endif // #ifdef _WIN32

#define CF_THREAD_FUNCTION	CF_THREAD_RETURN CF_THREAD_CALL

#define CF_ERROR_THREAD					CF_ERROR_BASE * 4
#define CF_ERROR_THREAD_CREATE			CF_ERROR_THREAD - 1
#define CF_ERROR_THREAD_INVALID_ARGS	CF_ERROR_THREAD - 2

#define CF_ERROR_MUTEX					CF_ERROR_BASE * 5
#define CF_ERROR_MUTEX_CREATE			CF_ERROR_MUTEX - 1
#define CF_ERROR_MUTEX_INVALID_ARGS		CF_ERROR_MUTEX - 2

typedef void *	CF_Thread;
typedef void *	CF_Mutex;

#ifdef __cplusplus
extern "C" {
#endif

CF_EXPORT int
CF_Thread_Create	(CF_Thread			* threadID,
					 CF_THREAD_RETURN	callback,
					 void				* arg);

CF_EXPORT int
CF_Thread_Release	(CF_Thread * threadID);

CF_EXPORT int
CF_Thread_Join		(CF_Thread * threadID);

CF_EXPORT int
CF_Mutex_Create		(CF_Mutex * mutex);

CF_EXPORT int
CF_Mutex_Destory	(CF_Mutex * mutex);

CF_EXPORT int
CF_Mutex_Lock		(CF_Mutex * mutex);

CF_EXPORT int
CF_Mutex_Unlock		(CF_Mutex * mutex);

#ifdef __cplusplus
}
#endif

#endif // #ifndef __CF_THREAD_H__
